jQuery(document).ready(function ($) {
    $(".mica_ecta_form").each(function () {
        $(this).validate({
            rules: {
                ecta_title: {
                    required: true,
                },
                ecta_title_size: {
                    number: true,
                },
                ecta_text_size: {
                    number: true,
                },
                ecta_button_size: {
                    number: true,
                },
                ecta_button_padding_top: {
                    number: true,
                },
                ecta_button_padding_right: {
                    number: true,
                },
                ecta_button_padding_bottom: {
                    number: true,
                },
                ecta_button_padding_left: {
                    number: true,
                },
                ecta_button_radius: {
                    number: true,
                },
                ecta_layout_radius: {
                    number: true,
                },
                ecta_layout_padding_top: {
                    number: true,
                },
                ecta_layout_padding_right: {
                    number: true,
                },
                ecta_layout_padding_bottom: {
                    number: true,
                },
                ecta_layout_padding_left: {
                    number: true,
                },
            },
            errorClass: "mecta_invalid",
            validClass: "mecta_valid",
        });
    });

    function generatePreview(formID) {
        var $ecta_title =
            $(formID + " #ecta_title").val() != ""
                ? $(formID + " #ecta_title").val()
                : "Example title";
        var $ecta_description =
            $(formID + " #ecta_description").val() != ""
                ? $(formID + " #ecta_description").val()
                : "Lorem ipsum dolor sit amet consectetur adipisicing elit. Exercitationem rem a, aperiam facilis temporibus assumenda nemo eaque totam labore! Cum perferendis temporibus animi culpa. Perspiciatis esse eveniet voluptatibus quod aperiam!";
        var $ecta_btn_text =
            $(formID + " #ecta_btn_text").val() != ""
                ? $(formID + " #ecta_btn_text").val()
                : "Button text";
        var $ecta_btn_link =
            $(formID + " #ecta_btn_link").val() != ""
                ? $(formID + " #ecta_btn_link").val()
                : "#";
        var $ecta_btn_target = $(formID + " #ecta_btn_target").is(":checked")
            ? "_blank"
            : false;
        var $ecta_title_size =
            $(formID + " #ecta_title_size").val() != ""
                ? $(formID + " #ecta_title_size").val()
                : "28";
        var $ecta_title_weight = $(formID + " #ecta_title_weight").val();
        var $ecta_title_color = $(formID + " #ecta_title_color").val();
        var $ecta_text_size =
            $(formID + " #ecta_text_size").val() != ""
                ? $(formID + " #ecta_text_size").val()
                : "16";
        var $ecta_text_weight = $(formID + " #ecta_text_weight").val();
        var $ecta_text_color = $(formID + " #ecta_text_color").val();
        var $ecta_button_size =
            $(formID + " #ecta_button_size").val() != ""
                ? $(formID + " #ecta_button_size").val()
                : "16";
        var $ecta_button_weight = $(formID + " #ecta_button_weight").val();
        var $ecta_button_color = $(formID + " #ecta_button_color").val();
        var $ecta_button_padding_top =
            $(formID + " #ecta_button_padding_top").val() != ""
                ? $(formID + " #ecta_button_padding_top").val()
                : "8";
        var $ecta_button_padding_right =
            $(formID + " #ecta_button_padding_right").val() != ""
                ? $(formID + " #ecta_button_padding_right").val()
                : "16";
        var $ecta_button_padding_bottom =
            $(formID + " #ecta_button_padding_bottom").val() != ""
                ? $(formID + " #ecta_button_padding_bottom").val()
                : "8";
        var $ecta_button_padding_left =
            $(formID + " #ecta_button_padding_left").val() != ""
                ? $(formID + " #ecta_button_padding_left").val()
                : "16";
        var $ecta_button_radius =
            $(formID + " #ecta_button_radius").val() != ""
                ? $(formID + " #ecta_button_radius").val()
                : "6";
        var $ecta_button_background = $(
            formID + " #ecta_button_background"
        ).val();
        var $ecta_layout_padding_top =
            $(formID + " #ecta_layout_padding_top").val() != ""
                ? $(formID + " #ecta_layout_padding_top").val()
                : "20";
        var $ecta_layout_padding_right =
            $(formID + " #ecta_layout_padding_right").val() != ""
                ? $(formID + " #ecta_layout_padding_right").val()
                : "30";
        var $ecta_layout_padding_bottom =
            $(formID + " #ecta_layout_padding_bottom").val() != ""
                ? $(formID + " #ecta_layout_padding_bottom").val()
                : "20";
        var $ecta_layout_padding_left =
            $(formID + " #ecta_layout_padding_left").val() != ""
                ? $(formID + " #ecta_layout_padding_left").val()
                : "30";
        var $ecta_layout_radius =
            $(formID + " #ecta_layout_radius").val() != ""
                ? $(formID + " #ecta_layout_radius").val()
                : "10";
        var $ecta_layout_color = $(formID + " #ecta_layout_color").val();
        var $ecta_layout_textalign = $(
            formID + " #ecta_layout_textalign"
        ).val();

        var $ecta_button_color_hover = $(
            formID + " #ecta_button_color_hover"
        ).val();
        var $ecta_button_background_hover = $(
            formID + " #ecta_button_background_hover"
        ).val();

        // Layout
        $(formID + " .mica_ecta_layout").css({
            backgroundColor: $ecta_layout_color,
            textAlign: $ecta_layout_textalign,
            borderRadius: $ecta_layout_radius + "px",
            paddingLeft: $ecta_layout_padding_left + "px",
            paddingRight: $ecta_layout_padding_right + "px",
            paddingBottom: $ecta_layout_padding_bottom + "px",
            paddingTop: $ecta_layout_padding_top + "px",
        });

        // Title
        $(formID + " .mica_ecta_title").html($ecta_title);
        $(formID + " .mica_ecta_title").css({
            fontSize: $ecta_title_size + "px",
            fontWeight: $ecta_title_weight,
            color: $ecta_title_color,
        });

        // Text
        $(formID + " .mica_ecta_text").html($ecta_description);
        $(formID + " .mica_ecta_text").css({
            fontSize: $ecta_text_size + "px",
            fontWeight: $ecta_text_weight,
            color: $ecta_text_color,
        });

        // Button
        $(formID + " .mica_ecta_btn").html($ecta_btn_text);
        $(formID + " .mica_ecta_btn").attr("href", $ecta_btn_link);
        if ($ecta_btn_target == "_blank") {
            $(formID + " .mica_ecta_btn").attr("target", $ecta_btn_target);
        } else {
            $(formID + " .mica_ecta_btn").removeAttr("target");
        }
        $(formID + " .mica_ecta_btn").css({
            fontSize: $ecta_button_size + "px",
            fontWeight: $ecta_button_weight,
            color: $ecta_button_color,
            backgroundColor: $ecta_button_background,
            paddingTop: $ecta_button_padding_top + "px",
            paddingRight: $ecta_button_padding_right + "px",
            paddingBottom: $ecta_button_padding_bottom + "px",
            paddingLeft: $ecta_button_padding_left + "px",
            borderRadius: $ecta_button_radius + "px",
        });
        $(formID + " .mica_ecta_btn").hover(
            function () {
                $(this).css({
                    backgroundColor: $ecta_button_background_hover,
                    color: $ecta_button_color_hover,
                });
            },
            function () {
                $(this).css({
                    backgroundColor: $ecta_button_background,
                    color: $ecta_button_color,
                });
            }
        );
        return true;
    }
    $("#addnewform").change(function () {
        generatePreview("#addnewform");
    });

    $("#editecta").change(function () {
        generatePreview("#editecta");
    });

    function findGetParameter(parameterName) {
        var result = null,
            tmp = [];
        location.search
            .substr(1)
            .split("&")
            .forEach(function (item) {
                tmp = item.split("=");
                if (tmp[0] === parameterName)
                    result = decodeURIComponent(tmp[1]);
            });
        return result;
    }
    var edit_id = findGetParameter("ecta_id")
        ? findGetParameter("ecta_id")
        : false;
    if (edit_id) {
        $("#editecta").modal("toggle");
        generatePreview("#editecta");
    }

    $("a[data-delete]").click(function () {
        var id = this.dataset.delete;
        if (
            confirm("Are you sure? You're deleting the call to action #" + id)
        ) {
            var url = SolicitudesAjax.url;
            $.ajax({
                type: "POST",
                url: url,
                data: {
                    action: "peticioneliminar",
                    nonce: SolicitudesAjax.seguridad,
                    id: id,
                },
                success: function () {
                    location.reload();
                },
            });
        }
    });

    $("a[data-duplicate]").click(function () {
        var id = this.dataset.duplicate;
        if (
            confirm(
                "Are you sure? You're duplicating the call to action #" + id
            )
        ) {
            var url = SolicitudesAjax.url;
            $.ajax({
                type: "POST",
                url: url,
                data: {
                    action: "peticionduplicar",
                    nonce: SolicitudesAjax.seguridad,
                    id: id,
                },
                success: function () {
                    location.reload();
                },
            });
        }
    });
});
