<?php 
    $current_page = admin_url( "admin.php?page=" . MICA_ECTA_PLUGIN_SLUG );
    $results = 0;
?>

<div class="wrap" id="mica_ecta">
    <?php echo "<h1 class='wp-heading-inline'>" . get_admin_page_title() . "</h1>"; ?>
    <a id="add-new" class="page-title-action" data-bs-toggle="modal" data-bs-target="#addnewecta">Add new</a>
    
    <div class="mt-4">
        <?php if($msge_notification) :?>
        <div class="mecta_notificacion">
            <?php echo wp_kses_post($msge_notification);?>
        </div>
        <?php endif;?>

        <table class="table table-striped">
            <thead>
                <tr>
                    <th class="py-2 px-4">ID</th>
                    <th class="py-2 px-4">Title</th>
                    <th class="py-2 px-4">Shortcode</th>
                    <th class="py-2 px-4">Author</th>
                    <th class="py-2 px-4">Actions</th>
                </tr>
            </thead>
            <tbody id="the-list">
                <?php 
                    if(empty($lista_ctas)){
                        echo "<tr><td colspan='5' style='text-align:center;'>There's 0 call to actions created.</td></tr>";
                    } else{
                        foreach ($lista_ctas as $key => $value) {
                            $results++;
                            $id = $value['cta_id'];
                            $title_json = json_decode($value['title']);
                            if($title_json->title){
                                $title = $title_json->title;
                            } else{
                                $title = '(No title)';
                            }
                            $author = get_user_by('id', $value['user_id']);
                            echo "
                                    <tr>
                                        <td class='py-2 px-4'>#$id</td>
                                        <td class='py-2 px-4'>" . esc_html($title) . "</td>
                                        <td class='py-2 px-4'>[ecta id='$id']</td>
                                        <td class='py-2 px-4'>{$author->user_nicename}</td>
                                        <td class='py-2 px-4'>
                                            <a data-edit='$id' name='mecta_btn_edit' class='mecta_btn mecta_btn_primary' href='{$current_page}&ecta_id=$id'>Edit</a>
                                            <a data-duplicate='$id' class='mecta_btn mecta_btn_secondary'>Duplicate</a>
                                            <a data-delete='$id' class='mecta_btn mecta_btn_danger'>Delete</a>
                                        </td>
                                    </tr>
                                ";
                        }
                    }

                    if($results <= 10 && $results >= 0){
                        $placeholderTD = "<tr><td class='py-2 px-4 text-center' colspan='5'>
                            <a id='add-new' class='mecta_btn mecta_btn_primary mt-5' data-bs-toggle='modal' data-bs-target='#addnewecta'>Add new Call To Action</a>
                        </td></tr>";
                        echo wp_kses_post($placeholderTD);
                    }
                ?>
            </tbody>
        </table>
    </div>

    <?php include_once 'add-new-template.php'; ?>
    <?php include_once 'edit-template.php'; ?>

</div>