<?php

function ecta_options(){

    global $wpdb;
    $mica_ecta_tabla = "{$wpdb->base_prefix}mica_ecta";

    $msge_notification = false;

    if(isset($_GET['status']) && $_GET['status'] == 'success'){
        $msge_notification = 'Call to action edited succesfully';
    }
    
    if(isset($_POST['btnsave'])){
        
        $ecta_title = ($_POST['ecta_title'] != "") ? sanitize_text_field($_POST['ecta_title']) : false;
        $ecta_description = ($_POST['ecta_description'] != "") ? wp_kses_post($_POST['ecta_description']) : false;
        $ecta_btn_text = ($_POST['ecta_btn_text'] != "") ? sanitize_text_field($_POST['ecta_btn_text']) : false;
        $ecta_btn_link = ($_POST['ecta_btn_link'] != "") ? sanitize_url($_POST['ecta_btn_link']) : false;
        $ecta_btn_target = isset($_POST['ecta_btn_target']) ? sanitize_text_field($_POST['ecta_btn_target']) : false;
        $ecta_title_size = ($_POST['ecta_title_size'] != "") ? sanitize_text_field($_POST['ecta_title_size']) : false;
        $ecta_title_weight = ($_POST['ecta_title_weight'] != "") ? sanitize_text_field($_POST['ecta_title_weight']) : false;
        $ecta_title_color = sanitize_hex_color($_POST['ecta_title_color']);
        $ecta_text_size = ($_POST['ecta_text_size'] != "") ? sanitize_text_field($_POST['ecta_text_size']) : false;
        $ecta_text_weight = ($_POST['ecta_text_weight'] != "") ? sanitize_text_field($_POST['ecta_text_weight']) : false;
        $ecta_text_color = sanitize_hex_color($_POST['ecta_text_color']);
        $ecta_button_size = ($_POST['ecta_button_size'] != "") ? sanitize_text_field($_POST['ecta_button_size']) : false;
        $ecta_button_weight = ($_POST['ecta_button_weight'] != "") ? sanitize_text_field($_POST['ecta_button_weight']) : false;
        $ecta_button_color = sanitize_hex_color($_POST['ecta_button_color']);
        $ecta_button_padding_top = ($_POST['ecta_button_padding_top'] != "") ? sanitize_text_field($_POST['ecta_button_padding_top']) : false;
        $ecta_button_padding_right = ($_POST['ecta_button_padding_right'] != "") ? sanitize_text_field($_POST['ecta_button_padding_right']) : false;
        $ecta_button_padding_bottom = ($_POST['ecta_button_padding_bottom'] != "") ? sanitize_text_field($_POST['ecta_button_padding_bottom']) : false;
        $ecta_button_padding_left = ($_POST['ecta_button_padding_left'] != "") ? sanitize_text_field($_POST['ecta_button_padding_left']) : false;
        $ecta_button_radius = ($_POST['ecta_button_radius'] != "") ? sanitize_text_field($_POST['ecta_button_radius']) : false;
        $ecta_button_background = sanitize_hex_color($_POST['ecta_button_background']);
        $ecta_button_color_hover = sanitize_hex_color($_POST['ecta_button_color_hover']);
        $ecta_button_background_hover = sanitize_hex_color($_POST['ecta_button_background_hover']);
        $ecta_layout_padding_top = ($_POST['ecta_layout_padding_top'] != "") ? sanitize_text_field($_POST['ecta_layout_padding_top']) : false;
        $ecta_layout_padding_right = ($_POST['ecta_layout_padding_right'] != "") ? sanitize_text_field($_POST['ecta_layout_padding_right']) : false;
        $ecta_layout_padding_bottom = ($_POST['ecta_layout_padding_bottom'] != "") ?sanitize_text_field( $_POST['ecta_layout_padding_bottom']) : false;
        $ecta_layout_padding_left = ($_POST['ecta_layout_padding_left'] != "") ? sanitize_text_field($_POST['ecta_layout_padding_left']) : false;
        $ecta_layout_radius = ($_POST['ecta_layout_radius'] != "") ? sanitize_text_field($_POST['ecta_layout_radius']) : false;
        $ecta_layout_color = sanitize_hex_color($_POST['ecta_layout_color']);
        $ecta_layout_textalign = ($_POST['ecta_layout_textalign'] != "") ? sanitize_text_field($_POST['ecta_layout_textalign']) : false;
    
        $title_array = [
            'title' => $ecta_title,
            'styles' => [
                'font_size' => $ecta_title_size,
                'font_weight' => $ecta_title_weight,
                'color' => $ecta_title_color
            ]
        ];

        $description_array = [
            'description' => $ecta_description,
            'styles' => [
                'font_size' => $ecta_text_size,
                'font_weight' => $ecta_text_weight,
                'color' => $ecta_text_color
            ]
        ];

        $button_array = [
            'button' => [
                'text' => $ecta_btn_text,
                'link' => $ecta_btn_link,
                'target' => $ecta_btn_target
            ],
            'styles' => [
                'font_size' => $ecta_button_size,
                'font_weight' => $ecta_button_weight,
                'color' => $ecta_button_color,
                'padding_top' => $ecta_button_padding_top,
                'padding_right' => $ecta_button_padding_right,
                'padding_bottom' => $ecta_button_padding_bottom,
                'padding_left' => $ecta_button_padding_left,
                'border_radius' => $ecta_button_radius,
                'background_color' => $ecta_button_background,
                'color_hover' => $ecta_button_color_hover,
                'background_color_hover' => $ecta_button_background_hover
            ]
        ];

        $layout_array = [
            'styles' => [
                'text_align' => $ecta_layout_textalign,
                'padding_top' => $ecta_layout_padding_top,
                'padding_right' => $ecta_layout_padding_right,
                'padding_bottom' => $ecta_layout_padding_bottom,
                'padding_left' => $ecta_layout_padding_left,
                'border_radius' => $ecta_layout_radius,
                'background_color' => $ecta_layout_color
            ]
        ];

        $data = [
            'cta_id' => null,
            'title' => json_encode($title_array),
            'description' => json_encode($description_array),
            'button' => json_encode($button_array),
            'layout' => json_encode($layout_array),
            'user_id' => get_current_user_id()
        ];

        $respuesta =  $wpdb->insert($mica_ecta_tabla,$data);

        if($respuesta){
            $msge_notification = 'Call to action created successfully';
        }

    }

    $mica_ecta_query = "SELECT * FROM $mica_ecta_tabla";
    $lista_ctas = $wpdb->get_results($mica_ecta_query,ARRAY_A);

    if(empty($lista_ctas)){
        $lista_ctas = [];
    }

    // admin template
    include_once 'admin-template.php';
}

    