<?php 

function mica_ecta_settings() {
	// check user capabilities
	if ( ! current_user_can( 'manage_options' ) ) {
		return;
	}
	?>
	<div class="wrap">
		<form action="options.php" method="post">
			<?php
			settings_fields( MICA_ECTA_PLUGIN_SLUG .'-settings' );
			do_settings_sections( MICA_ECTA_PLUGIN_SLUG .'-settings' );
			submit_button( __( 'Save Settings', 'mica_ecta' ) );
			?>
		</form>
	</div>
	<?php
}

function mecta_settings_init() {
    // register a new setting
    register_setting(MICA_ECTA_PLUGIN_SLUG .'-settings', 'mecta_settings');

    // register a new section
    add_settings_section(
        'mecta_settings_section',
        'Settings', 'mecta_settings_section_callback',
        MICA_ECTA_PLUGIN_SLUG .'-settings'
    );

    // register a new field
    add_settings_field(
        'mecta_settings_field',
        'Delete data on uninstall', 'mecta_settings_field_callback',
        MICA_ECTA_PLUGIN_SLUG .'-settings',
        'mecta_settings_section'
    );
}
add_action('admin_init', 'mecta_settings_init');

/**
 * callback functions
 */
// section content 
function mecta_settings_section_callback() {
    echo '<h1>Uninstall options</h1>';
}

// field content 
function mecta_settings_field_callback() {
    $setting = get_option('mecta_settings');
    // output the field
    ?>
    <input type="checkbox" name="mecta_settings" <?php echo ( $setting == 'on' ) ? 'checked' : ''; ?>><label>Delete all plugin data on uninstall</label>
    <?php
}