<?php

class ecta{

    public function mica_ecta_get_cta($cta_id){
        global $wpdb;
        $tabla = "{$wpdb->prefix}mica_ecta";
        $query = "SELECT * FROM $tabla WHERE cta_id = $cta_id";
        $datos = $wpdb->get_results($query,ARRAY_A);
        if(empty($datos)){
            $datos = ['Empty'];
        }
        return $datos[0];
    }

    public function mica_ecta_armador($cta_id_shortcode){
        $cta = $this->mica_ecta_get_cta($cta_id_shortcode);
        
        if($cta !== 'Empty'){
            // Objects
            $title_obj = json_decode($cta['title']);
            $description_obj = json_decode($cta['description']);
            $button_obj = json_decode($cta['button']);
            $layout_obj = json_decode($cta['layout']);

            // Content
            $title = sanitize_text_field($title_obj->title);
            $description = wp_kses_post($description_obj->description);
            $buttonText = sanitize_text_field($button_obj->button->text);
            $buttonLink = sanitize_url($button_obj->button->link);
            $buttonTarget = ($button_obj->button->target == 'on') ? 'target=\'_blank\'' : '';

            // Styles
            $titleStyle = $title_obj->styles;
            $descriptionStyle = $description_obj->styles;
            $buttonStyle = $button_obj->styles;
            $layoutStyle = $layout_obj->styles;

            // Values in px
            $layout_pt = $layoutStyle->padding_top ? sanitize_text_field($layoutStyle->padding_top) : '20';
            $layout_pb = $layoutStyle->padding_bottom ? sanitize_text_field($layoutStyle->padding_bottom) : '20';
            $layout_pl = ($layoutStyle->padding_left) ? sanitize_text_field($layoutStyle->padding_left) : '30';
            $layout_pr = ($layoutStyle->padding_right) ? sanitize_text_field($layoutStyle->padding_right) : '30';
            $layout_br = ($layoutStyle->border_radius) ? sanitize_text_field($layoutStyle->border_radius) : '10';

            $title_fs = ($titleStyle->font_size) ? sanitize_text_field($titleStyle->font_size) : '28';

            $description_fs = ($descriptionStyle->font_size) ? sanitize_text_field($descriptionStyle->font_size) : '16';

            $button_fs = ($buttonStyle->font_size) ? sanitize_text_field($buttonStyle->font_size) : '16';
            $button_pt = ($buttonStyle->padding_top) ? sanitize_text_field($buttonStyle->padding_top) : '8';
            $button_pb = ($buttonStyle->padding_bottom) ? sanitize_text_field($buttonStyle->padding_bottom) : '8';
            $button_pl = ($buttonStyle->padding_left) ? sanitize_text_field($buttonStyle->padding_left) : '16';
            $button_pr = ($buttonStyle->padding_right) ? sanitize_text_field($buttonStyle->padding_right) : '16';
            $button_br = ($buttonStyle->border_radius) ? sanitize_text_field($buttonStyle->border_radius) : '6';

            $customStyles = "
            <style>
                #mica_ecta_" . esc_html(number_format($cta_id_shortcode)) . ".mica_ecta_layout{
                    padding-top: " . esc_html(number_format($layout_pt)) . "px !important;
                    padding-bottom: " . esc_html(number_format($layout_pb)) . "px !important;
                    padding-left: " . esc_html(number_format($layout_pl)) . "px !important;
                    padding-right: " . esc_html(number_format($layout_pr)) . "px !important;
                    border-radius: " . esc_html(number_format($layout_br)) . "px !important;
                    background-color: " . esc_html($layoutStyle->background_color) . " !important;
                    text-align: " . esc_html($layoutStyle->text_align) . " !important;
                }

                #mica_ecta_" . esc_html(number_format($cta_id_shortcode)) . " .mica_ecta_title{
                    font-size: " . esc_html(number_format($title_fs)) . "px !important;
                    font-weight: " . esc_html(number_format($titleStyle->font_weight)) . " !important;
                    color: " . esc_html($titleStyle->color) . " !important;
                    line-height: 1.3 !important;
                    margin-top: 0 !important;
                    margin-bottom: 0.5rem !important;
                }

                #mica_ecta_" . esc_html(number_format($cta_id_shortcode)) . " .mica_ecta_text{
                    font-size: " . esc_html(number_format($description_fs)) . "px !important;
                    font-weight: " . esc_html(number_format($descriptionStyle->font_weight)) . " !important;
                    color: " . esc_html($descriptionStyle->color) . " !important;
                    line-height: 1.5 !important;
                    margin-top: 0 !important;
                    margin-bottom: 1rem !important;
                }
                
                #mica_ecta_" . esc_html(number_format($cta_id_shortcode)) . " .mica_ecta_btn{
                    font-size: " . esc_html(number_format($button_fs)) . "px !important;
                    font-weight: " . esc_html(number_format($buttonStyle->font_weight)) . " !important;
                    color: " . esc_html($buttonStyle->color) . " !important;
                    background-color: " . esc_html($buttonStyle->background_color) . " !important;
                    padding-top: " . esc_html(number_format($button_pt)) . "px !important;
                    padding-bottom: " . esc_html(number_format($button_pb)) . "px !important;
                    padding-left: " . esc_html(number_format($button_pl)) . "px !important;
                    padding-right: " . esc_html(number_format($button_pr)) . "px !important;
                    border-radius: " . esc_html(number_format($button_br)) . "px !important;
                    text-decoration: none !important;
                    outline: none !important;
                    transition: all 0.3s ease !important;
                    margin-top: 5px !important;
                    display: inline-block !important;
                }
                
                #mica_ecta_" . esc_html(number_format($cta_id_shortcode)) . " .mica_ecta_btn:hover{
                    color: " . esc_html($buttonStyle->color_hover) . " !important;
                    background-color: " . esc_html($buttonStyle->background_color_hover) . " !important;
                }
            </style>
            ";

            $customhtml = "<div id='mica_ecta_" . esc_html(number_format($cta_id_shortcode)) . "' class='mica_ecta_layout'>";
            if($title){
                $customhtml .= "<h3 class='mica_ecta_title'>" . esc_html($title) . "</h3>";
            }
            if($description){
                $customhtml .= "<p class='mica_ecta_text'>" . wp_kses_post($description) . "</p>";
            }
            if($buttonLink && $buttonText){
                $customhtml .= "<a href='" . esc_url($buttonLink) . "' class='mica_ecta_btn' " . esc_html($buttonTarget) . ">" . esc_html($buttonText) . "</a>";
            }
            $customhtml .= "</div>";

            $result = $customStyles . $customhtml;
        } else {
            $result = 'There\'s no Call To Action with the ID #' . esc_html(number_format($cta_id_shortcode)) . '.';
        }

        return $result;
    }
}